OpenTTD Source: NWidgetNewGRFDisplay Class Reference

OpenTTD Source 14.0-RC3

Public Member Functions | Data Fields | Static Public Attributes
NWidgetNewGRFDisplay Class Reference

Custom nested widget container for the NewGRF gui. More...

Inheritance diagram for NWidgetNewGRFDisplay:

## Public Member Functions
| NWidgetNewGRFDisplay (std::unique_ptr< NWidgetBase > &&avs, std::unique_ptr< NWidgetBase > &&acs, std::unique_ptr< NWidgetBase > &&inf)
void | SetupSmallestSize (Window *w) override
void | AssignSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height, bool rtl) override
void | FillWidgetLookup (WidgetLookup &widget_lookup) override
NWidgetCore * | GetWidgetFromPos (int x, int y) override
void | Draw (const Window *w) override
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor. More...
virtual void | AdjustPaddingForZoom ()
virtual NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type. More...
template<class NWID >
NWID * | GetParentWidget ()
| Get parent widget of type NWID. More...
template<class NWID >
const NWID * | GetParentWidget () const
| Get parent widget of type NWID. More...
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted ([[maybe_unused]] TextColour highlight_colour)
void | SetPadding (uint8_t top, uint8_t right, uint8_t bottom, uint8_t left)
| Set additional space (padding) around the widget. More...
void | SetPadding (const RectPadding &padding)
| Set additional space (padding) around the widget. More...
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step. More...
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step. More...
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint). More...
Rect | GetCurrentRect () const
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance. More...
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances. More...
void | operator delete (void *ptr)
| Memory release for a single class instance. More...
void | operator delete[] (void *ptr)
| Memory release for an array of class instances. More...

## Data Fields
std::unique_ptr< NWidgetBase > | avs
| Widget with the available grfs list and buttons.
std::unique_ptr< NWidgetBase > | acs
| Widget with the active grfs list and buttons.
std::unique_ptr< NWidgetBase > | inf
| Info panel.
bool | editable
| Editable status of the parent NewGRF window (if `false`, drop all widgets that make the window editable).
Data Fields inherited from NWidgetBase
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
int | pos_x
| Horizontal position of top-left corner of the widget in the window.
int | pos_y
| Vertical position of top-left corner of the widget in the window.
RectPadding | padding
| Padding added to the widget. Managed by parent container widget. (parent container may swap left and right for RTL)
RectPadding | uz_padding
| Unscaled padding, for resize calculation.
NWidgetBase * | parent
| Parent widget of this widget, automatically filled in when added to container.

## Static Public Attributes
static const uint | MAX_EXTRA_INFO_WIDTH = 150
| Maximal additional width given to the panel.
static const uint | MIN_EXTRA_FOR_3_COLUMNS = 50
| Minimal additional width needed before switching to 3 columns.

## Additional Inherited Members
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height)
| Store size and position. More...

## Detailed Description

Custom nested widget container for the NewGRF gui.

Depending on the space in the gui, it uses either

- two column mode, put the acs and the avs underneath each other and the inf next to it, or
- three column mode, put the avs, acs, and inf each in its own column.

Definition at line 1605 of file newgrf_gui.cpp.

## Member Function Documentation

## ◆ AssignSizePosition()

void NWidgetNewGRFDisplay::AssignSizePosition | ( | SizingType | sizing,
|  | int | x,
|  | int | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl
| ) |  |
| inlineoverridevirtual

Assign size and position to the widget.

Parameters

  sizing | Type of resizing to perform.
  x | Horizontal offset of the widget relative to the left edge of the window.
  y | Vertical offset of the widget relative to the top edge of the window.
  given_width | Width allocated to the widget.
  given_height | Height allocated to the widget.
  rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implements NWidgetBase.

Definition at line 1666 of file newgrf_gui.cpp.

## ◆ Draw()

void NWidgetNewGRFDisplay::Draw | ( | const Window * | w | ) |
| inlineoverridevirtual

Draw the widgets of the tree. The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 1802 of file newgrf_gui.cpp.

## ◆ FillWidgetLookup()

void NWidgetNewGRFDisplay::FillWidgetLookup | ( | WidgetLookup & | widget_lookup | ) |
| inlineoverridevirtual

Fill the Window::widget_lookup with pointers to nested widgets in the tree.

Parameters

  widget_lookup | The WidgetLookup.

Implements NWidgetBase.

Definition at line 1785 of file newgrf_gui.cpp.

## ◆ GetWidgetFromPos()

NWidgetCore* NWidgetNewGRFDisplay::GetWidgetFromPos | ( | int | x,
|  | int | y
| ) |  |
| inlineoverridevirtual

Retrieve a widget by its position.

Parameters

  x | Horizontal position relative to the left edge of the window.
  y | Vertical position relative to the top edge of the window.

Returns
  Returns the deepest nested widget that covers the given position, or `nullptr` if no widget can be found.

Implements NWidgetBase.

Definition at line 1792 of file newgrf_gui.cpp.

## ◆ SetupSmallestSize()

void NWidgetNewGRFDisplay::SetupSmallestSize | ( | Window * | w | ) |
| inlineoverridevirtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 1623 of file newgrf_gui.cpp.

References ComputeMaxSize(), NewGRFWindow::editable, NWidgetBase::fill_x, NWidgetBase::fill_y, WidgetDimensions::hsep_wide, NWidgetBase::resize_x, NWidgetBase::resize_y, WidgetDimensions::scaled, NWidgetBase::smallest_x, and NWidgetBase::smallest_y.

The documentation for this class was generated from the following file:

- src/newgrf_gui.cpp